/*
 * ARM Limited (ARM) is supplying this software for use with Cortex-M
 * processor based microcontroller, but can be equally used for other
 * suitable processor architectures. This file can be freely distributed.
 * Modifications to this file shall be clearly marked.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * @file     CMS32M55xx.h
 * @brief    CMSIS HeaderFile
 * @version  1.2
 * @date     08. November 2019
 * @note     Generated by SVDConv V3.3.21 on Friday, 08.11.2019 11:21:37
 *           from File 'CMS32M55xx.svd',
 *           last modified on Friday, 08.11.2019 03:20:55
 */



/** @addtogroup CMS Ltd.
  * @{
  */


/** @addtogroup CMS32M55xx
  * @{
  */


#ifndef CMS32M55XX_H
#define CMS32M55XX_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M0 Specific Interrupt Numbers  ======================================== */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* =========================================  CMS32M55xx Specific Interrupt Numbers  ========================================= */
  GPIO0_IRQn                =   0,              /*!< 0  P0[7:0] IRQ                                                            */
  GPIO1_IRQn                =   1,              /*!< 1  P1[7:0] IRQ                                                            */
  GPIO2_IRQn                =   2,              /*!< 2  P2[7:0] IRQ                                                            */
  GPIO3_IRQn                =   3,              /*!< 3  P3[7:0] IRQ                                                            */
  GPIO4_IRQn                =   4,              /*!< 4  P4[7:0] IRQ                                                            */
  CCP_IRQn                  =   6,              /*!< 6  Capture/PWM IRQ                                                        */
  ADC0_IRQn                 =   7,              /*!< 7  ADC0 IRQ                                                               */
  WWDT_IRQn                 =   9,              /*!< 9  WWDT IRQ                                                               */
  EPWM_IRQn                 =  10,              /*!< 10 EPWM IRQ                                                               */
  ADC1_IRQn                 =  12,              /*!< 12 ADC1 IRQ                                                               */
  ACMP_IRQn                 =  13,              /*!< 13 ACMP IRQ                                                               */
  UART0_IRQn                =  15,              /*!< 15 UART0 IRQ                                                              */
  UART1_IRQn                =  16,              /*!< 16 UART1 IRQ                                                              */
  TIMER0_IRQn               =  19,              /*!< 19 Timer0 IRQ                                                             */
  TIMER1_IRQn               =  20,              /*!< 20 Timer1 IRQ                                                             */
  WDT_IRQn                  =  23,              /*!< 23 Watchdog IRQ                                                           */
  I2C0_IRQn                 =  24,              /*!< 24 I2C IRQ                                                                */
  SSP0_IRQn                 =  26,              /*!< 26 SSP0 IRQ                                                               */
  SYS_CHK_IRQn              =  31               /*!< 31 SYS_CHK IRQ                                                            */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ===========================  Configuration of the ARM Cortex-M0 Processor and Core Peripherals  =========================== */
#define __CM0_REV                 0x0100U       /*!< CM0 Core Revision                                                         */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __MPU_PRESENT                  1        /*!< MPU present or not                                                        */
#define __FPU_PRESENT                  0        /*!< FPU present or not                                                        */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm0.h"                           /*!< ARM Cortex-M0 processor and core peripherals                              */
#include "system_CMS32M55xx.h"                  /*!< CMS32M55xx System                                                         */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                          SYSCON                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief SYSCON Decription (SYSCON)
  */

typedef struct {                                /*!< (@ 0x50000000) SYSCON Structure                                           */
  __IM  uint32_t  DID;                          /*!< (@ 0x00000000) DID Description                                            */
  __IOM uint32_t  AHBCKDIV;                     /*!< (@ 0x00000004) AHBCKDIV Description                                       */
  __IOM uint32_t  APBCKDIV;                     /*!< (@ 0x00000008) APBCKDIV Description                                       */
  __IOM uint32_t  APBCKEN;                      /*!< (@ 0x0000000C) APBCKEN Description                                        */
  __IOM uint32_t  CLKODIV;                      /*!< (@ 0x00000010) CLKODIV Description                                        */
  __IOM uint32_t  PCON;                         /*!< (@ 0x00000014) PCON Description                                           */
  __OM  uint32_t  RSTCON;                       /*!< (@ 0x00000018) RSTCON Description                                         */
  __IOM uint32_t  RSTSTAT;                      /*!< (@ 0x0000001C) RSTSTAT Description                                        */
  __IOM uint32_t  CLKCON;                       /*!< (@ 0x00000020) CLKCON Description                                         */
  __IOM uint32_t  CLKSEL;                       /*!< (@ 0x00000024) CLKSEL Description                                         */
  __IM  uint32_t  CLKSTAT;                      /*!< (@ 0x00000028) CLKSTAT Description                                        */
  __IOM uint32_t  APBCKSEL;                     /*!< (@ 0x0000002C) APBCKSEL Description                                       */
  __IM  uint32_t  IOMUX;                        /*!< (@ 0x00000030) IOMUX Description                                          */
  __IM  uint32_t  CIDL;                         /*!< (@ 0x00000034) CIDL Description                                           */
  __IM  uint32_t  CIDH;                         /*!< (@ 0x00000038) CIDH Description                                           */
  __IOM uint32_t  LVDCON;                       /*!< (@ 0x0000003C) LVDCON Description                                         */
  __IOM uint32_t  IOP00CFG;                     /*!< (@ 0x00000040) IOP00CFG Description                                       */
  __IOM uint32_t  IOP01CFG;                     /*!< (@ 0x00000044) IOP01CFG Description                                       */
  __IM  uint32_t  RESERVED[2];
  __IOM uint32_t  IOP04CFG;                     /*!< (@ 0x00000050) IOP04CFG Description                                       */
  __IOM uint32_t  IOP05CFG;                     /*!< (@ 0x00000054) IOP05CFG Description                                       */
  __IOM uint32_t  IOP06CFG;                     /*!< (@ 0x00000058) IOP06CFG Description                                       */
  __IOM uint32_t  IOP07CFG;                     /*!< (@ 0x0000005C) IOP07CFG Description                                       */
  __IOM uint32_t  IOP10CFG;                     /*!< (@ 0x00000060) IOP10CFG Description                                       */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  IOP12CFG;                     /*!< (@ 0x00000068) IOP12CFG Description                                       */
  __IOM uint32_t  IOP13CFG;                     /*!< (@ 0x0000006C) IOP13CFG Description                                       */
  __IOM uint32_t  IOP14CFG;                     /*!< (@ 0x00000070) IOP14CFG Description                                       */
  __IOM uint32_t  IOP15CFG;                     /*!< (@ 0x00000074) IOP15CFG Description                                       */
  __IOM uint32_t  IOP16CFG;                     /*!< (@ 0x00000078) IOP16CFG Description                                       */
  __IOM uint32_t  IOP17CFG;                     /*!< (@ 0x0000007C) IOP17CFG Description                                       */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  IOP21CFG;                     /*!< (@ 0x00000084) IOP21CFG Description                                       */
  __IOM uint32_t  IOP22CFG;                     /*!< (@ 0x00000088) IOP22CFG Description                                       */
  __IOM uint32_t  IOP23CFG;                     /*!< (@ 0x0000008C) IOP23CFG Description                                       */
  __IOM uint32_t  IOP24CFG;                     /*!< (@ 0x00000090) IOP24CFG Description                                       */
  __IOM uint32_t  IOP25CFG;                     /*!< (@ 0x00000094) IOP25CFG Description                                       */
  __IOM uint32_t  IOP26CFG;                     /*!< (@ 0x00000098) IOP26CFG Description                                       */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  IOP30CFG;                     /*!< (@ 0x000000A0) IOP30CFG Description                                       */
  __IOM uint32_t  IOP31CFG;                     /*!< (@ 0x000000A4) IOP31CFG Description                                       */
  __IOM uint32_t  IOP32CFG;                     /*!< (@ 0x000000A8) IOP32CFG Description                                       */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  IOP34CFG;                     /*!< (@ 0x000000B0) IOP34CFG Description                                       */
  __IOM uint32_t  IOP35CFG;                     /*!< (@ 0x000000B4) IOP35CFG Description                                       */
  __IOM uint32_t  IOP36CFG;                     /*!< (@ 0x000000B8) IOP36CFG Description                                       */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  IOP40CFG;                     /*!< (@ 0x000000C0) IOP40CFG Description                                       */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  IOP43CFG;                     /*!< (@ 0x000000CC) IOP43CFG Description                                       */
  __IOM uint32_t  IOP44CFG;                     /*!< (@ 0x000000D0) IOP44CFG Description                                       */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  IOP46CFG;                     /*!< (@ 0x000000D8) IOP46CFG Description                                       */
  __IOM uint32_t  IOP47CFG;                     /*!< (@ 0x000000DC) IOP47CFG Description                                       */
  __IM  uint32_t  RESERVED8[8];
  __IOM uint32_t  SYS_IMSC;                     /*!< (@ 0x00000100) SYS_IMSC Description                                       */
  __IM  uint32_t  SYS_RIS;                      /*!< (@ 0x00000104) SYS_RIS Description                                        */
  __IM  uint32_t  SYS_MIS;                      /*!< (@ 0x00000108) SYS_MIS Description                                        */
  __OM  uint32_t  SYS_ICLR;                     /*!< (@ 0x0000010C) SYS_ICLR Description                                       */
  __IOM uint32_t  HSI_TRIM;                     /*!< (@ 0x00000110) HSI_TRIM Description                                       */
  __IM  uint32_t  RESERVED9[39];
  __IOM uint32_t  SRAMLOCK;                     /*!< (@ 0x000001B0) SRAMLOCK Description                                       */
  __IM  uint32_t  RESERVED10[3];
  __IOM uint32_t  GPIO0LOCK;                    /*!< (@ 0x000001C0) GPIO0LOCK Description                                      */
  __IOM uint32_t  GPIO1LOCK;                    /*!< (@ 0x000001C4) GPIO1LOCK Description                                      */
  __IOM uint32_t  GPIO2LOCK;                    /*!< (@ 0x000001C8) GPIO2LOCK Description                                      */
  __IOM uint32_t  GPIO3LOCK;                    /*!< (@ 0x000001CC) GPIO3LOCK Description                                      */
  __IOM uint32_t  GPIO4LOCK;                    /*!< (@ 0x000001D0) GPIO4LOCK Description                                      */
  __IM  uint32_t  RESERVED11[10];
  __IOM uint32_t  IOCFGLOCK;                    /*!< (@ 0x000001FC) IOCFGLOCK Description                                      */
  __IM  uint32_t  RESERVED12[192];
  __IM  uint32_t  UIDX;                         /*!< (@ 0x00000500) UIDX Description                                           */
  __IM  uint32_t  RESERVED13[3];
  __IM  uint32_t  PCRCD;                        /*!< (@ 0x00000510) PCRCD Description                                          */
  __IM  uint32_t  RESERVED14[3];
  __IOM uint32_t  UUIDWC0;                      /*!< (@ 0x00000520) UUIDWC0 Description                                        */
  __IOM uint32_t  UUIDWC1;                      /*!< (@ 0x00000524) UUIDWC1 Description                                        */
  __IOM uint32_t  UUIDWC2;                      /*!< (@ 0x00000528) UUIDWC2 Description                                        */
  __IOM uint32_t  UUIDWCS;                      /*!< (@ 0x0000052C) UUIDWCS Description                                        */
} SYSCON_Type;                                  /*!< Size = 1328 (0x530)                                                       */

/* =========================================================================================================================== */
/* ================                                           GPIO0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO0 Decription (GPIO0)
  */

typedef struct {                                /*!< (@ 0x52000000) GPIO0 Structure                                            */
  __IOM uint32_t  GPIO0PMS;                     /*!< (@ 0x00000000) GPIO0PMS Description                                       */
  __IOM uint32_t  GPIO0DOM;                     /*!< (@ 0x00000004) GPIO0DOM Description                                       */
  __IOM uint32_t  GPIO0DO;                      /*!< (@ 0x00000008) GPIO0DO Description                                        */
  __IM  uint32_t  GPIO0DI;                      /*!< (@ 0x0000000C) GPIO0DI Description                                        */
  __IOM uint32_t  GPIO0IMSC;                    /*!< (@ 0x00000010) GPIO0IMSC Description                                      */
  __IM  uint32_t  GPIO0RIS;                     /*!< (@ 0x00000014) GPIO0RIS Description                                       */
  __IM  uint32_t  GPIO0MIS;                     /*!< (@ 0x00000018) GPIO0MIS Description                                       */
  __OM  uint32_t  GPIO0ICLR;                    /*!< (@ 0x0000001C) GPIO0ICLR Description                                      */
  __IOM uint32_t  GPIO0ITYPE;                   /*!< (@ 0x00000020) GPIO0ITYPE Description                                     */
  __IOM uint32_t  GPIO0IVAL;                    /*!< (@ 0x00000024) GPIO0IVAL Description                                      */
  __IOM uint32_t  GPIO0IANY;                    /*!< (@ 0x00000028) GPIO0IANY Description                                      */
  __IOM uint32_t  GPIO0DIDB;                    /*!< (@ 0x0000002C) GPIO0DIDB Description                                      */
  __OM  uint32_t  GPIO0DOSET;                   /*!< (@ 0x00000030) GPIO0DOSET Description                                     */
  __OM  uint32_t  GPIO0DOCLR;                   /*!< (@ 0x00000034) GPIO0DOCLR Description                                     */
  __IOM uint32_t  GPIO0DR;                      /*!< (@ 0x00000038) GPIO0DR Description                                        */
  __IOM uint32_t  GPIO0SR;                      /*!< (@ 0x0000003C) GPIO0SR Description                                        */
} GPIO0_Type;                                   /*!< Size = 64 (0x40)                                                          */



/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief WDT Decription (WDT)
  */

typedef struct {                                /*!< (@ 0x47800000) WDT Structure                                              */
  __IOM uint32_t  WDTCON;                       /*!< (@ 0x00000000) WDTCON Description                                         */
  __IOM uint32_t  WDTLOAD;                      /*!< (@ 0x00000004) WDTLOAD Description                                        */
  __IM  uint32_t  WDTVAL;                       /*!< (@ 0x00000008) WDTVAL Description                                         */
  __IM  uint32_t  WDTRIS;                       /*!< (@ 0x0000000C) WDTRIS Description                                         */
  __IM  uint32_t  WDTMIS;                       /*!< (@ 0x00000010) WDTMIS Description                                         */
  __OM  uint32_t  WDTICLR;                      /*!< (@ 0x00000014) WDTICLR Description                                        */
  __IM  uint32_t  RESERVED[314];
  __IOM uint32_t  WDTLOCK;                      /*!< (@ 0x00000500) WDTLOCK Description                                        */
} WDT_Type;                                     /*!< Size = 1284 (0x504)                                                       */



/* =========================================================================================================================== */
/* ================                                           WWDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief WWDT Decription (WWDT)
  */

typedef struct {                                /*!< (@ 0x41800000) WWDT Structure                                             */
  __IOM uint32_t  WWDTCON;                      /*!< (@ 0x00000000) WWDTCON Description                                        */
  __OM  uint32_t  WWDTRL;                       /*!< (@ 0x00000004) WWDTRL Description                                         */
  __IM  uint32_t  WWDTVAL;                      /*!< (@ 0x00000008) WWDTVAL Description                                        */
  __IM  uint32_t  WWDTRIS;                      /*!< (@ 0x0000000C) WWDTRIS Description                                        */
  __IM  uint32_t  WWDTMIS;                      /*!< (@ 0x00000010) WWDTMIS Description                                        */
  __OM  uint32_t  WWDTICLR;                     /*!< (@ 0x00000014) WWDTICLR Description                                       */
} WWDT_Type;                                    /*!< Size = 24 (0x18)                                                          */



/* =========================================================================================================================== */
/* ================                                            CRC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief CRC Decription (CRC)
  */

typedef struct {                                /*!< (@ 0x4A000000) CRC Structure                                              */
  __IOM uint32_t  CRCIN;                        /*!< (@ 0x00000000) CRCIN Description                                          */
  __IOM uint32_t  CRCD;                         /*!< (@ 0x00000004) CRCD Description                                           */
} CRC_Type;                                     /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                           HWDIV                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief HWDIV Decription (HWDIV)
  */

typedef struct {                                /*!< (@ 0x55000000) HWDIV Structure                                            */
  __IOM uint32_t  CON;                          /*!< (@ 0x00000000) CON Description                                            */
  __IOM uint32_t  DIVD;                         /*!< (@ 0x00000004) DIVD Description                                           */
  __IOM uint32_t  DIVS;                         /*!< (@ 0x00000008) DIVS Description                                           */
  __IM  uint32_t  DIVQ;                         /*!< (@ 0x0000000C) DIVQ Description                                           */
  __IM  uint32_t  DIVR;                         /*!< (@ 0x00000010) DIVR Description                                           */
} HWDIV_Type;                                   /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                          TIMER0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief TIMER0 Decription (TIMER0)
  */

typedef struct {                                /*!< (@ 0x46800000) TIMER0 Structure                                           */
  __IOM uint32_t  TIMER0CON;                    /*!< (@ 0x00000000) TIMER0CON Description                                      */
  __IOM uint32_t  TIMER0LOAD;                   /*!< (@ 0x00000004) TIMER0LOAD Description                                     */
  __IM  uint32_t  TIMER0VAL;                    /*!< (@ 0x00000008) TIMER0VAL Description                                      */
  __IM  uint32_t  TIMER0RIS;                    /*!< (@ 0x0000000C) TIMER0RIS Description                                      */
  __IM  uint32_t  TIMER0MIS;                    /*!< (@ 0x00000010) TIMER0MIS Description                                      */
  __OM  uint32_t  TIMER0ICLR;                   /*!< (@ 0x00000014) TIMER0ICLR Description                                     */
  __IOM uint32_t  TIMER0BGLOAD;                 /*!< (@ 0x00000018) TIMER0BGLOAD Description                                   */
} TIMER0_Type;                                  /*!< Size = 28 (0x1c)                                                          */



/* =========================================================================================================================== */
/* ================                                            CCP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief CCP Decription (CCP)
  */

typedef struct {                                /*!< (@ 0x42800000) CCP Structure                                              */
  __IOM uint32_t  CCPCON0;                      /*!< (@ 0x00000000) CCPCON0 Description                                        */
  __IOM uint32_t  CCPLOAD0;                     /*!< (@ 0x00000004) CCPLOAD0 Description                                       */
  __IOM uint32_t  CCPD0A;                       /*!< (@ 0x00000008) CCPD0A Description                                         */
  __IOM uint32_t  CCPD0B;                       /*!< (@ 0x0000000C) CCPD0B Description                                         */
  __IOM uint32_t  CCPCON1;                      /*!< (@ 0x00000010) CCPCON1 Description                                        */
  __IOM uint32_t  CCPLOAD1;                     /*!< (@ 0x00000014) CCPLOAD1 Description                                       */
  __IOM uint32_t  CCPD1A;                       /*!< (@ 0x00000018) CCPD1A Description                                         */
  __IOM uint32_t  CCPD1B;                       /*!< (@ 0x0000001C) CCPD1B Description                                         */
  __IM  uint32_t  RESERVED[8];
  __IOM uint32_t  CCPIMSC;                      /*!< (@ 0x00000040) CCPIMSC Description                                        */
  __IM  uint32_t  CCPRIS;                       /*!< (@ 0x00000044) CCPRIS Description                                         */
  __IM  uint32_t  CCPMIS;                       /*!< (@ 0x00000048) CCPMIS Description                                         */
  __OM  uint32_t  CCPICLR;                      /*!< (@ 0x0000004C) CCPICLR Description                                        */
  __IOM uint32_t  CCPRUN;                       /*!< (@ 0x00000050) CCPRUN Description                                         */
  __IOM uint32_t  CCPLOCK;                      /*!< (@ 0x00000054) CCPLOCK Description                                        */
  __IOM uint32_t  CAPCON;                       /*!< (@ 0x00000058) CAPCON Description                                         */
  __IOM uint32_t  CAPCHS;                       /*!< (@ 0x0000005C) CAPCHS Description                                         */
  __IOM uint32_t  CAP0DAT0;                     /*!< (@ 0x00000060) CAP0DAT0 Description                                       */
  __IOM uint32_t  CAP1DAT0;                     /*!< (@ 0x00000064) CAP1DAT0 Description                                       */
  __IOM uint32_t  CAP2DAT0;                     /*!< (@ 0x00000068) CAP2DAT0 Description                                       */
  __IOM uint32_t  CAP3DAT0;                     /*!< (@ 0x0000006C) CAP3DAT0 Description                                       */
} CCP_Type;                                     /*!< Size = 112 (0x70)                                                         */



/* =========================================================================================================================== */
/* ================                                           EPWM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief EPWM Decription (EPWM)
  */

typedef struct {                                /*!< (@ 0x4A800000) EPWM Structure                                             */
  __IOM uint32_t  CLKPSC;                       /*!< (@ 0x00000000) CLKPSC Description                                         */
  __IOM uint32_t  CLKDIV;                       /*!< (@ 0x00000004) CLKDIV Description                                         */
  __IOM uint32_t  CON;                          /*!< (@ 0x00000008) CON Description                                            */
  __IOM uint32_t  CON2;                         /*!< (@ 0x0000000C) CON2 Description                                           */
  __IOM uint32_t  CON3;                         /*!< (@ 0x00000010) CON3 Description                                           */
  __IOM uint32_t  PERIOD0;                      /*!< (@ 0x00000014) PERIOD0 Description                                        */
  __IOM uint32_t  PERIOD1;                      /*!< (@ 0x00000018) PERIOD1 Description                                        */
  __IOM uint32_t  PERIOD2;                      /*!< (@ 0x0000001C) PERIOD2 Description                                        */
  __IOM uint32_t  PERIOD3;                      /*!< (@ 0x00000020) PERIOD3 Description                                        */
  __IOM uint32_t  PERIOD4;                      /*!< (@ 0x00000024) PERIOD4 Description                                        */
  __IOM uint32_t  PERIOD5;                      /*!< (@ 0x00000028) PERIOD5 Description                                        */
  __IOM uint32_t  CMPDAT0;                      /*!< (@ 0x0000002C) CMPDAT0 Description                                        */
  __IOM uint32_t  CMPDAT1;                      /*!< (@ 0x00000030) CMPDAT1 Description                                        */
  __IOM uint32_t  CMPDAT2;                      /*!< (@ 0x00000034) CMPDAT2 Description                                        */
  __IOM uint32_t  CMPDAT3;                      /*!< (@ 0x00000038) CMPDAT3 Description                                        */
  __IOM uint32_t  CMPDAT4;                      /*!< (@ 0x0000003C) CMPDAT4 Description                                        */
  __IOM uint32_t  CMPDAT5;                      /*!< (@ 0x00000040) CMPDAT5 Description                                        */
  __IOM uint32_t  POREMAP;                      /*!< (@ 0x00000044) POREMAP Description                                        */
  __IOM uint32_t  POEN;                         /*!< (@ 0x00000048) POEN Description                                           */
  __IOM uint32_t  BRKCTL;                       /*!< (@ 0x0000004C) BRKCTL Description                                         */
  __IOM uint32_t  DTCTL;                        /*!< (@ 0x00000050) DTCTL Description                                          */
  __IOM uint32_t  MASK;                         /*!< (@ 0x00000054) MASK Description                                           */
  __IOM uint32_t  MASKNXT;                      /*!< (@ 0x00000058) MASKNXT Description                                        */
  __IOM uint32_t  CMPTGD0;                      /*!< (@ 0x0000005C) CMPTGD0 Description                                        */
  __IOM uint32_t  CMPTGD1;                      /*!< (@ 0x00000060) CMPTGD1 Description                                        */
  __IOM uint32_t  IMSC;                         /*!< (@ 0x00000064) IMSC Description                                           */
  __IM  uint32_t  RIS;                          /*!< (@ 0x00000068) RIS Description                                            */
  __IM  uint32_t  MIS;                          /*!< (@ 0x0000006C) MIS Description                                            */
  __OM  uint32_t  ICLR;                         /*!< (@ 0x00000070) ICLR Description                                           */
  __IOM uint32_t  IFA;                          /*!< (@ 0x00000074) IFA Description                                            */
  __IOM uint32_t  LOCK;                         /*!< (@ 0x00000078) LOCK Description                                           */
} EPWM_Type;                                    /*!< Size = 124 (0x7c)                                                         */



/* =========================================================================================================================== */
/* ================                                           UART0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief UART0 Decription (UART0)
  */

typedef struct {                                /*!< (@ 0x44800000) UART0 Structure                                            */
  __IM  uint32_t  UART0RBR;                     /*!< (@ 0x00000000) UART0RBR Description                                       */
  __OM  uint32_t  UART0THR;                     /*!< (@ 0x00000004) UART0THR Description                                       */
  __IOM uint32_t  UART0DLR;                     /*!< (@ 0x00000008) UART0DLR Description                                       */
  __IOM uint32_t  UART0IER;                     /*!< (@ 0x0000000C) UART0IER Description                                       */
  __IM  uint32_t  UART0IIR;                     /*!< (@ 0x00000010) UART0IIR Description                                       */
  __OM  uint32_t  UART0FCR;                     /*!< (@ 0x00000014) UART0FCR Description                                       */
  __IOM uint32_t  UART0LCR;                     /*!< (@ 0x00000018) UART0LCR Description                                       */
  __IOM uint32_t  UART0MCR;                     /*!< (@ 0x0000001C) UART0MCR Description                                       */
  __IM  uint32_t  UART0LSR;                     /*!< (@ 0x00000020) UART0LSR Description                                       */
  __IM  uint32_t  UART0MSR;                     /*!< (@ 0x00000024) UART0MSR Description                                       */
  __IOM uint32_t  UART0SCR;                     /*!< (@ 0x00000028) UART0SCR Description                                       */
  __IOM uint32_t  UART0EFR;                     /*!< (@ 0x0000002C) UART0EFR Description                                       */
  __IOM uint32_t  UART0XON1;                    /*!< (@ 0x00000030) UART0XON1 Description                                      */
  __IOM uint32_t  UART0XON2;                    /*!< (@ 0x00000034) UART0XON2 Description                                      */
  __IOM uint32_t  UART0XOFF1;                   /*!< (@ 0x00000038) UART0XOFF1 Description                                     */
  __IOM uint32_t  UART0XOFF2;                   /*!< (@ 0x0000003C) UART0XOFF2 Description                                     */
} UART0_Type;                                   /*!< Size = 64 (0x40)                                                          */



/* =========================================================================================================================== */
/* ================                                           I2C0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C0 Decription (I2C0)
  */

typedef struct {                                /*!< (@ 0x48000000) I2C0 Structure                                             */
  __IOM uint32_t  I2CCONSET;                    /*!< (@ 0x00000000) I2CCONSET Description                                      */
  __OM  uint32_t  I2CCONCLR;                    /*!< (@ 0x00000004) I2CCONCLR Description                                      */
  __IM  uint32_t  I2CSTAT;                      /*!< (@ 0x00000008) I2CSTAT Description                                        */
  __IOM uint32_t  I2CDAT;                       /*!< (@ 0x0000000C) I2CDAT Description                                         */
  __IOM uint32_t  I2CCLK;                       /*!< (@ 0x00000010) I2CCLK Description                                         */
  __IOM uint32_t  I2CADR0;                      /*!< (@ 0x00000014) I2CADR0 Description                                        */
  __IOM uint32_t  I2CADM0;                      /*!< (@ 0x00000018) I2CADM0 Description                                        */
  __IOM uint32_t  I2CXADR0;                     /*!< (@ 0x0000001C) I2CXADR0 Description                                       */
  __IOM uint32_t  I2CXADM0;                     /*!< (@ 0x00000020) I2CXADM0 Description                                       */
  __OM  uint32_t  I2CRST;                       /*!< (@ 0x00000024) I2CRST Description                                         */
  __IOM uint32_t  I2CADR1;                      /*!< (@ 0x00000028) I2CADR1 Description                                        */
  __IOM uint32_t  I2CADM1;                      /*!< (@ 0x0000002C) I2CADM1 Description                                        */
  __IOM uint32_t  I2CADR2;                      /*!< (@ 0x00000030) I2CADR2 Description                                        */
  __IOM uint32_t  I2CADM2;                      /*!< (@ 0x00000034) I2CADM2 Description                                        */
  __IOM uint32_t  I2CADR3;                      /*!< (@ 0x00000038) I2CADR3 Description                                        */
  __IOM uint32_t  I2CADM3;                      /*!< (@ 0x0000003C) I2CADM3 Description                                        */
} I2C0_Type;                                    /*!< Size = 64 (0x40)                                                          */



/* =========================================================================================================================== */
/* ================                                           SSP0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief SSP0 Decription (SSP0)
  */

typedef struct {                                /*!< (@ 0x43800000) SSP0 Structure                                             */
  __IOM uint32_t  SSPCON;                       /*!< (@ 0x00000000) SSPCON Description                                         */
  __IM  uint32_t  SSPSTAT;                      /*!< (@ 0x00000004) SSPSTAT Description                                        */
  __IOM uint32_t  SSPDAT;                       /*!< (@ 0x00000008) SSPDAT Description                                         */
  __IOM uint32_t  SSPCLK;                       /*!< (@ 0x0000000C) SSPCLK Description                                         */
  __IOM uint32_t  SSPIMSC;                      /*!< (@ 0x00000010) SSPIMSC Description                                        */
  __IM  uint32_t  SSPRIS;                       /*!< (@ 0x00000014) SSPRIS Description                                         */
  __IM  uint32_t  SSPMIS;                       /*!< (@ 0x00000018) SSPMIS Description                                         */
  __OM  uint32_t  SSPICLR;                      /*!< (@ 0x0000001C) SSPICLR Description                                        */
  __IM  uint32_t  RESERVED[2];
  __IOM uint32_t  SSPCSCR;                      /*!< (@ 0x00000028) SSPCSCR Description                                        */
} SSP0_Type;                                    /*!< Size = 44 (0x2c)                                                          */



/* =========================================================================================================================== */
/* ================                                           ADC0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief ADC0 Decription (ADC0)
  */

typedef struct {                                /*!< (@ 0x43000000) ADC0 Structure                                             */
  __IOM uint32_t  ADCCON;                       /*!< (@ 0x00000000) ADCCON Description                                         */
  __IOM uint32_t  ADCCON2;                      /*!< (@ 0x00000004) ADCCON2 Description                                        */
  __IOM uint32_t  ADCHWTG;                      /*!< (@ 0x00000008) ADCHWTG Description                                        */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  ADCSCAN;                      /*!< (@ 0x00000010) ADCSCAN Description                                        */
  __IOM uint32_t  ADCCMP0;                      /*!< (@ 0x00000014) ADCCMP0 Description                                        */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  ADCIMSC;                      /*!< (@ 0x0000001C) ADCIMSC Description                                        */
  __IM  uint32_t  ADCRIS;                       /*!< (@ 0x00000020) ADCRIS Description                                         */
  __IM  uint32_t  ADCMIS;                       /*!< (@ 0x00000024) ADCMIS Description                                         */
  __OM  uint32_t  ADCICLR;                      /*!< (@ 0x00000028) ADCICLR Description                                        */
  __IOM uint32_t  ADCLOCK;                      /*!< (@ 0x0000002C) ADCLOCK Description                                        */
  __IM  uint32_t  RESERVED2[20];
  __IM  uint32_t  ADCDATA0;                     /*!< (@ 0x00000080) ADCDATA0 Description                                       */
  __IM  uint32_t  ADCDATA1;                     /*!< (@ 0x00000084) ADCDATA1 Description                                       */
  __IM  uint32_t  ADCDATA2;                     /*!< (@ 0x00000088) ADCDATA2 Description                                       */
  __IM  uint32_t  ADCDATA3;                     /*!< (@ 0x0000008C) ADCDATA3 Description                                       */
  __IM  uint32_t  ADCDATA4;                     /*!< (@ 0x00000090) ADCDATA4 Description                                       */
  __IM  uint32_t  ADCDATA5;                     /*!< (@ 0x00000094) ADCDATA5 Description                                       */
  __IM  uint32_t  ADCDATA6;                     /*!< (@ 0x00000098) ADCDATA6 Description                                       */
  __IM  uint32_t  ADCDATA7;                     /*!< (@ 0x0000009C) ADCDATA7 Description                                       */
  __IM  uint32_t  ADCDATA8;                     /*!< (@ 0x000000A0) ADCDATA8 Description                                       */
  __IM  uint32_t  ADCDATA9;                     /*!< (@ 0x000000A4) ADCDATA9 Description                                       */
  __IM  uint32_t  ADCDATA10;                    /*!< (@ 0x000000A8) ADCDATA10 Description                                      */
  __IM  uint32_t  ADCDATA11;                    /*!< (@ 0x000000AC) ADCDATA11 Description                                      */
  __IM  uint32_t  ADCDATA12;                    /*!< (@ 0x000000B0) ADCDATA12 Description                                      */
  __IM  uint32_t  ADCDATA13;                    /*!< (@ 0x000000B4) ADCDATA13 Description                                      */
  __IM  uint32_t  ADCDATA14;                    /*!< (@ 0x000000B8) ADCDATA14 Description                                      */
  __IM  uint32_t  ADCDATA15;                    /*!< (@ 0x000000BC) ADCDATA15 Description                                      */
  __IM  uint32_t  ADCDATA16;                    /*!< (@ 0x000000C0) ADCDATA16 Description                                      */
  __IM  uint32_t  ADCDATA17;                    /*!< (@ 0x000000C4) ADCDATA17 Description                                      */
  __IM  uint32_t  ADCDATA18;                    /*!< (@ 0x000000C8) ADCDATA18 Description                                      */
  __IM  uint32_t  ADCDATA19;                    /*!< (@ 0x000000CC) ADCDATA19 Description                                      */
  __IM  uint32_t  ADCDATA20;                    /*!< (@ 0x000000D0) ADCDATA20 Description                                      */
  __IM  uint32_t  ADCDATA21;                    /*!< (@ 0x000000D4) ADCDATA21 Description                                      */
  __IM  uint32_t  ADCDATA22;                    /*!< (@ 0x000000D8) ADCDATA22 Description                                      */
  __IM  uint32_t  ADCDATA23;                    /*!< (@ 0x000000DC) ADCDATA23 Description                                      */
  __IM  uint32_t  ADCDATA24;                    /*!< (@ 0x000000E0) ADCDATA24 Description                                      */
  __IM  uint32_t  ADCDATA25;                    /*!< (@ 0x000000E4) ADCDATA25 Description                                      */
  __IM  uint32_t  ADCDATA26;                    /*!< (@ 0x000000E8) ADCDATA26 Description                                      */
  __IM  uint32_t  ADCDATA27;                    /*!< (@ 0x000000EC) ADCDATA27 Description                                      */
  __IM  uint32_t  ADCDATA28;                    /*!< (@ 0x000000F0) ADCDATA28 Description                                      */
  __IM  uint32_t  ADCDATA29;                    /*!< (@ 0x000000F4) ADCDATA29 Description                                      */
  __IM  uint32_t  ADCDATA30;                    /*!< (@ 0x000000F8) ADCDATA30 Description                                      */
} ADC0_Type;                                    /*!< Size = 252 (0xfc)                                                         */



/* =========================================================================================================================== */
/* ================                                           ADC1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief ADC1 Decription (ADC1)
  */

typedef struct {                                /*!< (@ 0x4D800000) ADC1 Structure                                             */
  __IOM uint32_t  ADCCON;                       /*!< (@ 0x00000000) ADCCON Description                                         */
  __IOM uint32_t  ADCCON2;                      /*!< (@ 0x00000004) ADCCON2 Description                                        */
  __IOM uint32_t  ADCHWTG;                      /*!< (@ 0x00000008) ADCHWTG Description                                        */
  __IOM uint32_t  ADCPWMTGDLY;                  /*!< (@ 0x0000000C) ADCPWMTGDLY Description                                    */
  __IOM uint32_t  ADCSCAN;                      /*!< (@ 0x00000010) ADCSCAN Description                                        */
  __IOM uint32_t  ADCCMP0;                      /*!< (@ 0x00000014) ADCCMP0 Description                                        */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  ADCIMSC;                      /*!< (@ 0x0000001C) ADCIMSC Description                                        */
  __IM  uint32_t  ADCRIS;                       /*!< (@ 0x00000020) ADCRIS Description                                         */
  __IM  uint32_t  ADCMIS;                       /*!< (@ 0x00000024) ADCMIS Description                                         */
  __OM  uint32_t  ADCICLR;                      /*!< (@ 0x00000028) ADCICLR Description                                        */
  __IOM uint32_t  ADCLOCK;                      /*!< (@ 0x0000002C) ADCLOCK Description                                        */
  __IOM uint32_t  ADCCHEPWM;                    /*!< (@ 0x00000030) ADCCHEPWM Description                                      */
  __IOM uint32_t  ADCCHPTG0;                    /*!< (@ 0x00000034) ADCCHPTG0 Description                                      */
  __IOM uint32_t  ADCCHPTG1;                    /*!< (@ 0x00000038) ADCCHPTG1 Description                                      */
  __IM  uint32_t  RESERVED1[17];
  __IM  uint32_t  ADCDATA0;                     /*!< (@ 0x00000080) ADCDATA0 Description                                       */
  __IM  uint32_t  ADCDATA1;                     /*!< (@ 0x00000084) ADCDATA1 Description                                       */
  __IM  uint32_t  ADCDATA2;                     /*!< (@ 0x00000088) ADCDATA2 Description                                       */
  __IM  uint32_t  ADCDATA3;                     /*!< (@ 0x0000008C) ADCDATA3 Description                                       */
  __IM  uint32_t  ADCDATA4;                     /*!< (@ 0x00000090) ADCDATA4 Description                                       */
  __IM  uint32_t  ADCDATA5;                     /*!< (@ 0x00000094) ADCDATA5 Description                                       */
  __IM  uint32_t  ADCDATA6;                     /*!< (@ 0x00000098) ADCDATA6 Description                                       */
  __IM  uint32_t  ADCDATA7;                     /*!< (@ 0x0000009C) ADCDATA7 Description                                       */
  __IM  uint32_t  ADCDATA8;                     /*!< (@ 0x000000A0) ADCDATA8 Description                                       */
  __IM  uint32_t  ADCDATA9;                     /*!< (@ 0x000000A4) ADCDATA9 Description                                       */
  __IM  uint32_t  ADCDATA10;                    /*!< (@ 0x000000A8) ADCDATA10 Description                                      */
  __IM  uint32_t  ADCDATA11;                    /*!< (@ 0x000000AC) ADCDATA11 Description                                      */
  __IM  uint32_t  ADCDATA12;                    /*!< (@ 0x000000B0) ADCDATA12 Description                                      */
  __IM  uint32_t  ADCDATA13;                    /*!< (@ 0x000000B4) ADCDATA13 Description                                      */
  __IM  uint32_t  ADCDATA14;                    /*!< (@ 0x000000B8) ADCDATA14 Description                                      */
  __IM  uint32_t  ADCDATA15;                    /*!< (@ 0x000000BC) ADCDATA15 Description                                      */
  __IM  uint32_t  ADCDATA16;                    /*!< (@ 0x000000C0) ADCDATA16 Description                                      */
  __IM  uint32_t  ADCDATA17;                    /*!< (@ 0x000000C4) ADCDATA17 Description                                      */
  __IM  uint32_t  ADCDATA18;                    /*!< (@ 0x000000C8) ADCDATA18 Description                                      */
  __IM  uint32_t  ADCDATA19;                    /*!< (@ 0x000000CC) ADCDATA19 Description                                      */
  __IM  uint32_t  ADCDATA20;                    /*!< (@ 0x000000D0) ADCDATA20 Description                                      */
  __IM  uint32_t  ADCDATA21;                    /*!< (@ 0x000000D4) ADCDATA21 Description                                      */
  __IM  uint32_t  ADCDATA22;                    /*!< (@ 0x000000D8) ADCDATA22 Description                                      */
  __IM  uint32_t  ADCDATA23;                    /*!< (@ 0x000000DC) ADCDATA23 Description                                      */
  __IM  uint32_t  ADCDATA24;                    /*!< (@ 0x000000E0) ADCDATA24 Description                                      */
  __IM  uint32_t  ADCDATA25;                    /*!< (@ 0x000000E4) ADCDATA25 Description                                      */
  __IM  uint32_t  ADCDATA26;                    /*!< (@ 0x000000E8) ADCDATA26 Description                                      */
  __IM  uint32_t  ADCDATA27;                    /*!< (@ 0x000000EC) ADCDATA27 Description                                      */
  __IM  uint32_t  ADCDATA28;                    /*!< (@ 0x000000F0) ADCDATA28 Description                                      */
  __IM  uint32_t  ADCDATA29;                    /*!< (@ 0x000000F4) ADCDATA29 Description                                      */
  __IM  uint32_t  ADCDATA30;                    /*!< (@ 0x000000F8) ADCDATA30 Description                                      */
} ADC1_Type;                                    /*!< Size = 252 (0xfc)                                                         */



/* =========================================================================================================================== */
/* ================                                            OP                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief OP Decription (OP)
  */

typedef struct {                                /*!< (@ 0x4C800000) OP Structure                                               */
  __IOM uint32_t  OP0CON0;                      /*!< (@ 0x00000000) OP0CON0 Description                                        */
  __IOM uint32_t  OP0CON1;                      /*!< (@ 0x00000004) OP0CON1 Description                                        */
  __IOM uint32_t  OP0ADJE;                      /*!< (@ 0x00000008) OP0ADJE Description                                        */
  __IOM uint32_t  OP1CON0;                      /*!< (@ 0x0000000C) OP1CON0 Description                                        */
  __IOM uint32_t  OP1CON1;                      /*!< (@ 0x00000010) OP1CON1 Description                                        */
  __IOM uint32_t  OP1ADJE;                      /*!< (@ 0x00000014) OP1ADJE Description                                        */
  __IOM uint32_t  PGA0CON;                      /*!< (@ 0x00000018) PGA0CON Description                                        */
  __IM  uint32_t  RESERVED[2];
  __IOM uint32_t  PGA1CON;                      /*!< (@ 0x00000024) PGA1CON Description                                        */
} OP_Type;                                      /*!< Size = 40 (0x28)                                                          */



/* =========================================================================================================================== */
/* ================                                           ACMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief ACMP Decription (ACMP)
  */

typedef struct {                                /*!< (@ 0x4D000000) ACMP Structure                                             */
  __IOM uint32_t  C0CON0;                       /*!< (@ 0x00000000) C0CON0 Description                                         */
  __IOM uint32_t  C0CON1;                       /*!< (@ 0x00000004) C0CON1 Description                                         */
  __IOM uint32_t  C0CON2;                       /*!< (@ 0x00000008) C0CON2 Description                                         */
  __IOM uint32_t  C0ADJE;                       /*!< (@ 0x0000000C) C0ADJE Description                                         */
  __IOM uint32_t  C1CON0;                       /*!< (@ 0x00000010) C1CON0 Description                                         */
  __IOM uint32_t  C1CON1;                       /*!< (@ 0x00000014) C1CON1 Description                                         */
  __IOM uint32_t  C1CON2;                       /*!< (@ 0x00000018) C1CON2 Description                                         */
  __IOM uint32_t  C1ADJE;                       /*!< (@ 0x0000001C) C1ADJE Description                                         */
  __IOM uint32_t  CVRCON;                       /*!< (@ 0x00000020) CVRCON Description                                         */
  __IOM uint32_t  CVECON;                       /*!< (@ 0x00000024) CVECON Description                                         */
  __IOM uint32_t  IMSC;                         /*!< (@ 0x00000028) IMSC Description                                           */
  __IM  uint32_t  RIS;                          /*!< (@ 0x0000002C) RIS Description                                            */
  __IM  uint32_t  MIS;                          /*!< (@ 0x00000030) MIS Description                                            */
  __OM  uint32_t  ICLR;                         /*!< (@ 0x00000034) ICLR Description                                           */
  __IOM uint32_t  LOCK;                         /*!< (@ 0x00000038) LOCK Description                                           */
} ACMP_Type;                                    /*!< Size = 60 (0x3c)                                                          */



/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief FMC Decription (FMC)
  */

typedef struct {                                /*!< (@ 0x49800000) FMC Structure                                              */
  __IOM uint32_t  FMCCON;                       /*!< (@ 0x00000000) FMCCON Description                                         */
  __IOM uint32_t  FMCADR;                       /*!< (@ 0x00000004) FMCADR Description                                         */
  __IOM uint32_t  FMCDAT;                       /*!< (@ 0x00000008) FMCDAT Description                                         */
  __IOM uint32_t  FMCCMD;                       /*!< (@ 0x0000000C) FMCCMD Description                                         */
  __IOM uint32_t  FMCLOCK;                      /*!< (@ 0x00000010) FMCLOCK Description                                        */
  __IM  uint32_t  RESERVED[3];
  __IOM uint32_t  FMCCRCEA;                     /*!< (@ 0x00000020) FMCCRCEA Description                                       */
  __IOM uint32_t  FMCCRCIN;                     /*!< (@ 0x00000024) FMCCRCIN Description                                       */
  __IOM uint32_t  FMCCRCD;                      /*!< (@ 0x00000028) FMCCRCD Description                                        */
} FMC_Type;                                     /*!< Size = 44 (0x2c)                                                          */



/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief UID Decription (UID)
  */

typedef struct {                                /*!< (@ 0x18000000) UID Structure                                              */
  __IM  uint32_t  RESERVED;
  __IM  uint32_t  UID0;                         /*!< (@ 0x00000004) UID0 Description                                           */
  __IM  uint32_t  UID1;                         /*!< (@ 0x00000008) UID1 Description                                           */
  __IM  uint32_t  UID2;                         /*!< (@ 0x0000000C) UID2 Description                                           */
} UID_Type;                                     /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define SYSCON_BASE                 0x50000000UL
#define GPIO0_BASE                  0x52000000UL
#define GPIO1_BASE                  0x52800000UL
#define GPIO2_BASE                  0x53000000UL
#define GPIO3_BASE                  0x53800000UL
#define GPIO4_BASE                  0x54000000UL
#define WDT_BASE                    0x47800000UL
#define WWDT_BASE                   0x41800000UL
#define CRC_BASE                    0x4A000000UL
#define HWDIV_BASE                  0x55000000UL
#define TIMER0_BASE                 0x46800000UL
#define TIMER1_BASE                 0x46800100UL
#define CCP_BASE                    0x42800000UL
#define EPWM_BASE                   0x4A800000UL
#define UART0_BASE                  0x44800000UL
#define UART1_BASE                  0x45000000UL
#define I2C0_BASE                   0x48000000UL
#define SSP0_BASE                   0x43800000UL
#define ADC0_BASE                   0x43000000UL
#define ADC1_BASE                   0x4D800000UL
#define OP_BASE                     0x4C800000UL
#define ACMP_BASE                   0x4D000000UL
#define FMC_BASE                    0x49800000UL
#define UID_BASE                    0x18000000UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define SYSCON                      ((SYSCON_Type*)            SYSCON_BASE)
#define GPIO0                       ((GPIO0_Type*)             GPIO0_BASE)
#define GPIO1                       ((GPIO0_Type*)             GPIO1_BASE)
#define GPIO2                       ((GPIO0_Type*)             GPIO2_BASE)
#define GPIO3                       ((GPIO0_Type*)             GPIO3_BASE)
#define GPIO4                       ((GPIO0_Type*)             GPIO4_BASE)
#define WDT                         ((WDT_Type*)               WDT_BASE)
#define WWDT                        ((WWDT_Type*)              WWDT_BASE)
#define CRC                         ((CRC_Type*)               CRC_BASE)
#define HWDIV                       ((HWDIV_Type*)             HWDIV_BASE)
#define TIMER0                      ((TIMER0_Type*)            TIMER0_BASE)
#define TIMER1                      ((TIMER0_Type*)            TIMER1_BASE)
#define CCP                         ((CCP_Type*)               CCP_BASE)
#define EPWM                        ((EPWM_Type*)              EPWM_BASE)
#define UART0                       ((UART0_Type*)             UART0_BASE)
#define UART1                       ((UART0_Type*)             UART1_BASE)
#define I2C0                        ((I2C0_Type*)              I2C0_BASE)
#define SSP0                        ((SSP0_Type*)              SSP0_BASE)
#define ADC0                        ((ADC0_Type*)              ADC0_BASE)
#define ADC1                        ((ADC1_Type*)              ADC1_BASE)
#define OP                          ((OP_Type*)                OP_BASE)
#define ACMP                        ((ACMP_Type*)              ACMP_BASE)
#define FMC                         ((FMC_Type*)               FMC_BASE)
#define UID                         ((UID_Type*)               UID_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


#ifdef __cplusplus
}
#endif

#endif /* CMS32M55XX_H */


/** @} */ /* End of group CMS32M55xx */

/** @} */ /* End of group CMS Ltd. */
